#ifndef FB_ERROR_CODE_MSG_C_HEADER
#define FB_ERROR_CODE_MSG_C_HEADER
/******************************************************************
**
**                    MURMUR Message Utility
**
** File: ../include/fb_error_code_msg_c.h
** Created: Thu Oct  8 15:21:29 1992
** Message Input File: ../include/fb_error_code.msg
** By User: votava
**
******************************************************************/
/* ****************************** Copyright Notice ****************************** */
/* *                                                                            * */
/* * Copyright (c) 1992 Universities Research Association, Inc.                 * */
/* *               All Rights Reserved.                                         * */
/* *                                                                            * */
/* ****************************************************************************** */
/* * */
/*  */
/* File:		fb_error_code.msg */
/* ==== */
/*  */
/* Author:	Margaret Votava */
/* ======		on-line support */
/* 		Fermilab MS 120 */
/* 		P.O. Box 500 */
/* 		Batavia, IL  60510 */
/* 		(708) 840-2625 */
/* 		e-mail: "votava@fnal.fnal.gov" */
/*  */
/* Creation date:	19-Aug-1992 */
/* ============== */
/*  */
/* Revision history:- */
/* ================= */
/*  */
/* 19-Aug-1992	creation */
/*  */
/*  */
/* Description:- */
/* ============ */
/*  */
/* 	Murmur message generation file for FASTBUS standard routine  */
/* error/status codes. */
/*  */
/*  */
#define FSR_facnum 0X2F
/*  */
/*  first define hardware errors. These need to have error numbers 1-n */
/*  because they will be used as array indices. */
/*  */
#define	   FEAKDO    0X800BC00C
#define	   FEAKTO    0X800BC014
#define	   FEBSS2    0X800BC01B
#define	   FEDPE    0X800BC024
#define	   FEDSS0    0X800BC029
#define	   FEDSS1    0X800BC034
#define	   FEDSS2    0X800BC03C
#define	   FEDSS3    0X800BC044
#define	   FEDSS4    0X800BC04C
#define	   FEDSS5    0X800BC054
#define	   FEDSS6    0X800BC05C
#define	   FEDSS7    0X800BC064
#define	   FEDKDO    0X800BC06C
#define	   FEDKTO    0X800BC074
#define	   FELOTO    0X800BC07C
#define	   FEASS0    0X800BC081
#define	   FEASS1    0X800BC08C
#define	   FEASS2    0X800BC094
#define	   FEASS3    0X800BC09C
#define	   FEASS4    0X800BC0A4
#define	   FEASS5    0X800BC0AC
#define	   FEASS6    0X800BC0B4
#define	   FEASS7    0X800BC0BC
#define	   FESATO    0X800BC0C4
#define	   FESSS0    0X800BC0C9
#define	   FESSS1    0X800BC0D4
#define	   FESSS2    0X800BC0DC
#define	   FESSS3    0X800BC0E4
#define	   FESSS4    0X800BC0EC
#define	   FESSS5    0X800BC0F4
#define	   FESSS6    0X800BC0FC
#define	   FESSS7    0X800BC104
#define	   FESOTO    0X800BC10C
#define	   FEWTTO    0X800BC114
/*  */
/*  non-hardware errors */
/*  */
#define	   FENORM    0X800BC119
#define	   FEBUF    0X800BC124
#define	   FEABA    0X800BC12A
#define	   FEACON    0X800BC134
#define	   FEBPRV    0X800BC13A
#define	   FEBOV    0X800BC144
#define	   FECLSD    0X800BC14C
#define	   FECON    0X800BC154
#define	   FEDCON    0X800BC15C
#define	   FEENAC    0X800BC164
#define	   FEEIOV    0X800BC16C
#define	   FEENOV    0X800BC174
#define	   FEEREL    0X800BC17C
#define	   FEERR    0X800BC184
#define	   FEFTL    0X800BC18C
#define	   FEHERR    0X800BC194
#define	   FEHWRN    0X800BC19A
#define	   FEHDAS    0X800BC1A3
#define	   FEHDFB    0X800BC1AB
#define	   FEIGNO    0X800BC1B1
#define	   FEIPRV    0X800BC1BC
#define	   FEILSI    0X800BC1C4
#define	   FEIMP    0X800BC1CC
#define	   FEINFO    0X800BC1D3
#define	   FEINEI    0X800BC1DC
#define	   FEINLI    0X800BC1E4
#define	   FEINPO    0X800BC1EC
#define	   FEINSI    0X800BC1F4
#define	   FELPAD    0X800BC1FB
#define	   FELSAD    0X800BC203
#define	   FELPTR    0X800BC20C
#define	   FELOV    0X800BC214
#define	   FELOON    0X800BC21B
#define	   FENOAS    0X800BC224
#define	   FENMST    0X800BC22C
#define	   FENPRV    0X800BC234
#define	   FENSST    0X800BC23B
#define	   FENCON    0X800BC242
#define	   FENHMA    0X800BC249
#define	   FENOMA    0X800BC254
#define	   FEOPEN    0X800BC25A
#define	   FEPEND    0X800BC262
#define	   FEPPL    0X800BC26C
#define	   FEPOV    0X800BC274
#define	   FEPAC    0X800BC27C
#define	   FEPAL    0X800BC284
#define	   FEPNAL    0X800BC28C
#define	   FEPNOP    0X800BC294
#define	   FEPOWN    0X800BC29B
#define	   FEROPA    0X800BC2A4
#define	   FERTY    0X800BC2AB
#define	   FESBAC    0X800BC2B4
#define	   FESBEX    0X800BC2BA
#define	   FESIOV    0X800BC2C4
#define	   FESOON    0X800BC2CB
#define	   FENSF    0X800BC2D4
#define	   FESOV    0X800BC2DC
#define	   FESUCC    0X800BC2E1
#define	   FEOOPS    0X800BC2EC
#define	   FEUNPR    0X800BC2F4
#define	   FEUPOP    0X800BC2FC
#define	   FEUPAR    0X800BC302
#define	   FEUROU    0X800BC30C
#define	   FEUAOV    0X800BC314
#define	   FEWARN    0X800BC31A
/*  */
/* **** BEGIN FSCC specific for now  */
/*  */
#define	   FEFIFO    0X800BC324
#endif
